'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createPatchProperties = createPatchProperties;
/* @flow */

/*:: import type {ElementProxy} from './ElementProxy'*/


function patchProperties(elementProxy /*: ElementProxy*/, props /*: Object*/, oldProps /*: Object*/) /*: Object*/ {
  for (var key in props) {
    if (props[key] !== oldProps[key]) {
      elementProxy.setAttribute(key, props[key]);
    }
  }

  for (var _key in oldProps) {
    if (!(_key in props)) {
      elementProxy.removeAttribute(_key);
    }
  }

  return props;
}

function createPatchProperties(elementProxy /*: ElementProxy*/) /*: Function*/ {
  var previous /*: Object*/ = {};

  return function (next /*: Object*/) /*: void*/ {
    previous = patchProperties(elementProxy, next, previous);
  };
}