'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.emitMount = emitMount;
exports.emitUnmount = emitUnmount;

var _CustomEvent = require('./CustomEvent');

var _is = require('./is');

/* @flow */

/*:: type MountableElement = {
  parentNode: Node;
  dispatchEvent (event: CustomEvent): boolean;
}*/
function emitMount(node /*: MountableElement*/, fn /*: Function | void*/) /*: void*/ {
  if (((0, _is.isFunction)(fn) || (0, _is.isSubject)(fn)) && node.parentNode) {
    var _event /*: CustomEvent*/ = new _CustomEvent.CustomEvent('mount');
    node.dispatchEvent(_event);
  }
}

function emitUnmount(node /*: MountableElement*/, fn /*: Function | void*/) /*: void*/ {
  if (((0, _is.isFunction)(fn) || (0, _is.isSubject)(fn)) && node.parentNode) {
    var _event2 /*: CustomEvent*/ = new _CustomEvent.CustomEvent('unmount');
    node.dispatchEvent(_event2);
  }
}